## libloki 0.1.3

=== Makefile ===
DESTDIR := $(CURDIR)/$(DESTDIR)

.PHONY: build check install clean
build:
	$(MAKE) -C src

check: build
	$(MAKE) -C test

install:
	$(MAKE) -C src install
	$(MAKE) -C include install

clean:
	$(MAKE) -C src clean
	$(MAKE) -C test clean

=== src/Makefile ===
OBJ = Singleton.o SmallObj.o OrderedStatic.o
BIN = ../lib/libloki.a
CXXFLAGS = -I../include -Wall -O2 -DNDEBUG

$(BIN): $(OBJ)
	ar rs $(BIN) $(OBJ)

.PHONY: clean install
install: $(BIN)
	mkdir -p $(DESTDIR)/usr/lib
	install $(BIN) $(DESTDIR)/usr/lib

clean:
	rm -f $(OBJ) $(BIN)

=== test/Factory/Makefile ===
OBJ = Factory.o
BIN = main-gcc
CXXFLAGS = -I../../include -Wall -O2 -DNDEBUG
LIBS = -L../../lib -lloki

$(BIN): $(OBJ)
	$(CXX) -o $(BIN) $(OBJ) $(LIBS)

.PHONY: clean
clean:
	rm -f $(OBJ) $(BIN)

=== test/Longevity/Makefile ===
OBJ1 = main.o
OBJ2 = main2.o
BIN1 = main-gcc
BIN2 = main2-gcc
CXXFLAGS = -I../../include -Wall -O2 -DNDEBUG
LIBS = -L../../lib -lloki

.PHONY: all
all: $(BIN1) $(BIN2)

$(BIN1): $(OBJ1)
	$(CXX) -o $(BIN1) $(OBJ1) $(LIBS)

$(BIN2): $(OBJ2)
	$(CXX) -o $(BIN2) $(OBJ2) $(LIBS)

.PHONY: clean
clean:
	rm -f $(OBJ1) $(BIN1)
	rm -f $(OBJ2) $(BIN2)

=== test/OrderedStatic/Makefile ===
OBJ = main.o
BIN = main-gcc
CXXFLAGS = -I../../include -Wall -O2 -DNDEBUG
LIBS = -L../../lib -lloki

$(BIN): $(OBJ)
	$(CXX) -o $(BIN) $(OBJ) $(LIBS)

.PHONY: clean
clean:
	rm -f $(OBJ) $(BIN)

=== test/RegressionTest/Makefile ===
OBJ = Test.o
BIN = main-gcc
CXXFLAGS = -I../../include -Wall -O2 -DNDEBUG
LIBS = -L../../lib -lloki

$(BIN): $(OBJ)
	$(CXX) -o $(BIN) $(OBJ) $(LIBS)

.PHONY: clean
clean:
	rm -f $(OBJ) $(BIN)

=== test/SafeFormat/Makefile ===
OBJ = main.o
BIN = main-gcc
CXXFLAGS = -I../../include -Wall -O2 -DNDEBUG
LIBS = 

$(BIN): $(OBJ)
	$(CXX) -o $(BIN) $(OBJ) $(LIBS)

.PHONY: clean
clean:
	rm -f $(OBJ) $(BIN)

=== test/Singleton/Makefile ===
OBJ1 = DeletableSingleton.o
OBJ2 = Dependencies.o
OBJ3 = Phoenix.o
BIN1 = deletable-singleton-gcc
BIN2 = dependencies-gcc
BIN3 = phoenix-gcc
CXXFLAGS = -I../../include -Wall -O2 -DNDEBUG
LIBS = -L../../lib -lloki

.PHONY: all
all: $(BIN1) $(BIN2) $(BIN3)

$(BIN1): $(OBJ1)
	$(CXX) -o $(BIN1) $(OBJ1) $(LIBS)

$(BIN2): $(OBJ2)
	$(CXX) -o $(BIN2) $(OBJ2) $(LIBS)

$(BIN3): $(OBJ3)
	$(CXX) -o $(BIN3) $(OBJ3) $(LIBS)

.PHONY: clean
clean:
	rm -f $(OBJ1) $(BIN1)
	rm -f $(OBJ2) $(BIN2)
	rm -f $(OBJ3) $(BIN3)

=== test/SmallObj/Makefile ===
OBJ1 = SmallObjBench.o
OBJ2 = SmallObjSingleton.o
BIN1 = small-obj-bench-gcc
BIN2 = small-obj-singleton-gcc
CXXFLAGS = -I../../include -Wall -fexpensive-optimizations -O3 -DNDEBUG
LIBS = -L../../lib -lloki

.PHONY: all
all: $(BIN1) $(BIN2)

$(BIN1): $(OBJ1)
	$(CXX) -o $(BIN1) $(OBJ1) $(LIBS)

$(BIN2): $(OBJ2)
	$(CXX) -o $(BIN2) $(OBJ2) $(LIBS)

.PHONY: clean
clean:
	rm -f $(OBJ1) $(BIN1)
	rm -f $(OBJ2) $(BIN2)

=== test/flex_string/Makefile ===
OBJ = main.o
BIN = main-gcc
CXXFLAGS = -I../../include -Wall -O2 -DNDEBUG

$(BIN): $(OBJ)
	$(CXX) -o $(BIN) $(OBJ)

.PHONY: clean
clean:
	rm -f $(OBJ) $(BIN)

## libloki 0.1.5

=== Makefile ===
export VERSION = 0.1.5
export OS ?= $(shell uname -s)

export CXXWARNFLAGS = -Wall -Wold-style-cast -Wundef -Wsign-compare -Wconversion -Wpointer-arith -pedantic
export CXXFLAGS = $(CXXWARNFLAGS) -g -O2

.PHONY: all build-static build-shared check clean distclean
all: build-static build-shared check
build-static:
	$(MAKE) -C src build-static

build-shared:
	$(MAKE) -C src build-shared

check: build-shared
	$(MAKE) -C test

clean:
	$(MAKE) -C src clean
	$(MAKE) -C test clean

distclean: clean
	$(MAKE) -C src distclean

ifneq ($(OS),Windows)
export prefix ?= /usr

.PHONY: install install-static
install:
	$(MAKE) -C src install-static
	$(MAKE) -C src install-shared
	$(MAKE) -C include install

install-static:
	$(MAKE) -C src install-static
	$(MAKE) -C include install
endif

=== include/Makefile ===
.PHONY: install
install:
	mkdir -p $(prefix)/include/loki
	mkdir -p $(prefix)/include/loki/flex
	mkdir -p $(prefix)/include/loki/yasli
	
	install -m 644 loki/*.h $(prefix)/include/loki
	install -m 644 loki/flex/*.h $(prefix)/include/loki/flex
	install -m 644 loki/yasli/*.h $(prefix)/include/loki/yasli

=== src/Makefile ===
SRC = $(wildcard *.cpp)
STATIC_OBJ = $(SRC:.cpp=.o)
SHARED_OBJ = $(SRC:.cpp=.lo)

CPPFLAGS = -I../include -DNDEBUG

STATIC_LIB = libloki.a

ifeq ($(OS), Darwin)
  SHARED_LIB_BASE = libloki.dylib
  SHARED_LIB_VERSIONED = libloki.$(VERSION).dylib
  LDFLAGS = -dynamiclib -single_module -install_name $(SHARED_LIB_VERSIONED) -fPIC
  LDLIBS = -lpthread
  RESULT_DIR = ../lib/
else
ifeq ($(OS), Linux)
  SHARED_LIB_BASE = libloki.so
  SHARED_LIB_VERSIONED = libloki.so.$(VERSION)
  LDFLAGS = --shared -Wl,-soname=$(SHARED_LIB_VERSIONED) -fPIC
  LDLIBS = -lpthread
  RESULT_DIR = ../lib/
else
  SHARED_LIB_BASE = libloki.dll
  LDFLAGS = --shared
  LDLIBS =
  RESULT_DIR = ../lib/
endif
endif

.PHONY: all build-static build-shared clean distclean
all: build-static build-shared
build-static: $(RESULT_DIR)$(STATIC_LIB)
build-shared: $(RESULT_DIR)$(SHARED_LIB_BASE)

clean:
	$(RM) $(STATIC_OBJ)
ifneq ($(OS), Windows)
	$(RM) $(SHARED_OBJ)
endif

distclean: clean
	$(RM) $(RESULT_DIR)$(STATIC_LIB)
	$(RM) $(RESULT_DIR)$(SHARED_LIB_BASE)
ifneq ($(OS),Windows)
	$(RM) $(RESULT_DIR)$(SHARED_LIB_VERSIONED)

INSTALL = install
INSTALL_DATA = $(INSTALL) -m 644

.PHONY: install install-static install-shared
install: install-static install-shared

install-static: $(RESULT_DIR)$(STATIC_LIB)
	mkdir -p $(prefix)/lib
	$(INSTALL_DATA) $(RESULT_DIR)$(STATIC_LIB) $(prefix)/lib

install-shared: $(RESULT_DIR)$(SHARED_LIB_BASE)
	mkdir -p $(prefix)/lib
	$(INSTALL_DATA) $(RESULT_DIR)$(SHARED_LIB_BASE) $(prefix)/lib
	$(INSTALL_DATA) $(RESULT_DIR)$(SHARED_LIB_VERSIONED) $(prefix)/lib

$(RESULT_DIR)$(SHARED_LIB_BASE): $(RESULT_DIR)$(SHARED_LIB_VERSIONED)
	ln -sf $^ $@

%.lo : %.cpp
	$(CXX) -c $(CXXFLAGS) -fPIC $(CPPFLAGS) -o $@ $<

$(RESULT_DIR)$(SHARED_LIB_VERSIONED): $(SHARED_OBJ)
else
$(RESULT_DIR)$(SHARED_LIB_BASE): $(STATIC_OBJ)
endif
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(RESULT_DIR)$(STATIC_LIB): $(STATIC_OBJ)
	$(AR) $(ARFLAGS) $@ $^

=== test/Makefile ===
export CPPFLAGS = -I../../include -DNDEBUG
export LDFLAGS = -L../../lib
export LDLIBS = -lloki

ifeq ($(OS),Windows)
export BIN_SUFFIX = .exe
else
export BIN_SUFFIX =
endif

SUBTARGETS_ORIG := $(patsubst %/,%,$(dir $(wildcard */Makefile)))
SUBTARGETS := $(filter-out $(SUBTARGETS_FILTER_OUT),$(SUBTARGETS_ORIG))
	
SUBTARGETS_CLEAN := $(addsuffix -clean,$(SUBTARGETS))

.PHONY: all clean $(SUBTARGETS) $(SUBTARGETS_CLEAN)
all: $(SUBTARGETS)
clean: $(SUBTARGETS_CLEAN)

$(SUBTARGETS):
	$(MAKE) -C $@

$(SUBTARGETS_CLEAN):
	$(MAKE) -C $(@:-clean=) clean

=== test/DeletableSingleton/Makefile ===
BIN = DeletableSingleton$(BIN_SUFFIX)
SRC = DeletableSingleton.cpp
OBJ = $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean:
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

=== test/Factory/Makefile ===
BIN = Factory$(BIN_SUFFIX)
SRC = Factory.cpp
OBJ = $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean:
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

=== test/Function/Makefile ===
BIN = FunctionTest$(BIN_SUFFIX)
SRC = FunctionTest.cpp
OBJ = $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean:
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

=== test/LockingPtr/Makefile ===
BIN = main$(BIN_SUFFIX)
SRC = main.cpp
OBJ = $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean:
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

=== test/Longevity/Makefile ===
BIN1 = main$(BIN_SUFFIX)
SRC1 = main.cpp
OBJ1 = $(SRC1:.cpp=.o)
BIN2 = main2$(BIN_SUFFIX)
SRC2 = main2.cpp
OBJ2 = $(SRC2:.cpp=.o)
override CXXFLAGS = $(CXXWARNFLAGS) -g -fexpensive-optimizations -O3

.PHONY: all clean
all: $(BIN1) $(BIN2)
clean:
	$(RM) $(BIN1)
	$(RM) $(OBJ1)
	$(RM) $(BIN2)
	$(RM) $(OBJ2)

$(BIN1): $(OBJ1)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(BIN2): $(OBJ2)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

=== test/Register/Makefile ===
BIN1 = main$(BIN_SUFFIX)
SRC1 = main.cpp
OBJ1 = $(SRC1:.cpp=.o)
LIB1 = libfoo.a
SRC2 = foo.cpp
OBJ2 = $(SRC2:.cpp=.o)
override CPPFLAGS += -DLOKI_FUNCTOR_IS_NOT_A_SMALLOBJECT

.PHONY: all clean
all: $(BIN1)

$(BIN1): $(OBJ1) $(LIB1) 
	$(CXX) $(CXXFLAGS) -L. $(LDFLAGS) $(CPPFLAGS) -o $@ $(OBJ1) $(LDLIBS) -lfoo

$(LIB1): $(OBJ2)
	$(AR) $(ARFLAGS) $@ $^

clean:
	$(RM) $(BIN1)
	$(RM) $(OBJ1)
	$(RM) $(LIB1)
	$(RM) $(OBJ2)

=== test/RegressionTest/Makefile ===
BIN = Test$(BIN_SUFFIX)
SRC = Test.cpp
OBJ = $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean:
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

=== test/SafeFormat/Makefile ===
BIN = main$(BIN_SUFFIX)
SRC = main.cpp
OBJ = $(SRC:.cpp=.o)
override CXXFLAGS = $(CXXWARNFLAGS) -g -fexpensive-optimizations -O3

.PHONY: all clean
all: $(BIN)
clean:
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

## libloki 0.1.7

=== Makefile ===
include Makefile.common

.PHONY: all build-static build-shared check clean distclean
all: build-static build-shared check
build-static:
	$(MAKE) -C src build-static

build-shared:
	$(MAKE) -C src build-shared

check: build-static build-shared
	$(MAKE) -C test

clean:
	$(MAKE) -C src clean
	$(MAKE) -C test clean

distclean: clean
	$(MAKE) -C src distclean

ifneq ($(OS),Windows)
.PHONY: install install-static
install:
	$(MAKE) -C src install-static
	$(MAKE) -C src install-shared
	$(MAKE) -C include install

install-static:
	$(MAKE) -C src install-static
	$(MAKE) -C include install
endif

=== include/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+include ../Makefile.common
+
 .PHONY: install
 install:
 	mkdir -p $(prefix)/include/loki

=== src/Makefile ===
include ../Makefile.common

SRC := $(wildcard *.cpp)
STATIC_OBJ := $(SRC:.cpp=.o)
SHARED_OBJ := $(SRC:.cpp=.lo)

override CPPFLAGS += -I../include -DNDEBUG

STATIC_LIB := libloki.a

ifeq ($(OS), Darwin)
  SHARED_LIB_BASE := libloki.dylib
  SHARED_LIB_VERSIONED := libloki.$(VERSION).dylib
  override LDFLAGS += -dynamiclib -single_module -install_name $(SHARED_LIB_VERSIONED) -fPIC
  LDLIBS := -lpthread
else
ifeq ($(OS), Linux)
  SHARED_LIB_BASE := libloki.so
  SHARED_LIB_VERSIONED := libloki.so.$(VERSION)
  override LDFLAGS += --shared -Wl,-soname=$(SHARED_LIB_VERSIONED) -fPIC
  LDLIBS := -lpthread
else
ifeq ($(OS), GNU/kFreeBSD)
  SHARED_LIB_BASE := libloki.so
  SHARED_LIB_VERSIONED := libloki.so.$(VERSION)
  override LDFLAGS += --shared -Wl,-soname=$(SHARED_LIB_VERSIONED) -fPIC
  LDLIBS := -lpthread
else
ifeq ($(OS), GNU)
  SHARED_LIB_BASE := libloki.so
  SHARED_LIB_VERSIONED := libloki.so.$(VERSION)
  override LDFLAGS += --shared -Wl,-soname=$(SHARED_LIB_VERSIONED) -fPIC
  LDLIBS := -lpthread
else
ifeq ($(OS), HP-UX)
  SHARED_LIB_BASE := libloki.so
  SHARED_LIB_VERSIONED := libloki.so.$(VERSION)
  override LDFLAGS += --shared -fPIC -mlp64
  override CXXFLAGS += -mlp64
  LDLIBS := -lpthread
  RESULT_DIR := ../lib/
else
  SHARED_LIB_VERSIONED := libloki.dll
  override LDFLAGS += --shared
  LDLIBS :=
endif
endif
endif
endif
endif

RESULT_DIR := ../lib/

.PHONY: all build-static build-shared clean distclean
all: build-static build-shared
build-static: $(RESULT_DIR)$(STATIC_LIB)
build-shared: $(RESULT_DIR)$(SHARED_LIB_VERSIONED)

clean:
	$(RM) $(STATIC_OBJ)
ifneq ($(OS), Windows)
	$(RM) $(SHARED_OBJ)
endif

distclean: clean cleandeps
	$(RM) $(RESULT_DIR)$(STATIC_LIB)
	$(RM) $(RESULT_DIR)$(SHARED_LIB_VERSIONED)

ifneq ($(OS),Windows)
INSTALL := install
INSTALL_DATA := $(INSTALL) -m 644

.PHONY: install install-static install-shared
install: install-static install-shared

install-static: $(RESULT_DIR)$(STATIC_LIB)
	mkdir -p $(prefix)/lib
	$(INSTALL_DATA) $(RESULT_DIR)$(STATIC_LIB) $(prefix)/lib

install-shared: $(RESULT_DIR)$(SHARED_LIB_VERSIONED)
	mkdir -p $(prefix)/lib
	$(INSTALL_DATA) $(RESULT_DIR)$(SHARED_LIB_VERSIONED) $(prefix)/lib
	cd $(prefix)/lib; ln -s $(SHARED_LIB_VERSIONED) $(SHARED_LIB_BASE)

%.lo : %.cpp
	$(CXX) -c $(CXXFLAGS) -fPIC $(CPPFLAGS) -o $@ $<

$(RESULT_DIR)$(SHARED_LIB_VERSIONED): $(SHARED_OBJ)
else
$(RESULT_DIR)$(SHARED_LIB_VERSIONED): $(STATIC_OBJ)
endif
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(RESULT_DIR)$(STATIC_LIB): $(STATIC_OBJ)
	$(AR) $(ARFLAGS) $@ $^

include ../Makefile.deps

=== test/Makefile ===
SUBTARGETS_ORIG := $(patsubst %/,%,$(dir $(wildcard */Makefile)))
SUBTARGETS_FILTER_OUT := flex_string
SUBTARGETS := $(filter-out $(SUBTARGETS_FILTER_OUT),$(SUBTARGETS_ORIG))
	
SUBTARGETS_CLEAN := $(addsuffix -clean,$(SUBTARGETS))

.PHONY: all clean $(SUBTARGETS) $(SUBTARGETS_CLEAN)
all: $(SUBTARGETS)
clean: $(SUBTARGETS_CLEAN)

$(SUBTARGETS):
	$(MAKE) -C $@

$(SUBTARGETS_CLEAN):
	$(MAKE) -C $(@:-clean=) clean

=== test/CachedFactory/Makefile ===
include ../Makefile.common

BIN := CachedFactoryTest$(BIN_SUFFIX)
SRC := CachedFactoryTest.cpp
OBJ := $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean: cleandeps
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

include ../../Makefile.deps

=== test/DeletableSingleton/Makefile ===
include ../Makefile.common

BIN := DeletableSingleton$(BIN_SUFFIX)
SRC := DeletableSingleton.cpp
OBJ := $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean: cleandeps
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

include ../../Makefile.deps

=== test/Factory/Makefile ===
include ../Makefile.common

BIN := Factory$(BIN_SUFFIX)
SRC := Factory.cpp
OBJ := $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean: cleandeps
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

include ../../Makefile.deps

=== test/Function/Makefile ===
include ../Makefile.common

BIN := FunctionTest$(BIN_SUFFIX)
SRC := FunctionTest.cpp
OBJ := $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean: cleandeps
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

include ../../Makefile.deps

=== test/LockingPtr/Makefile ===
include ../Makefile.common

BIN := main$(BIN_SUFFIX)
SRC := main.cpp
OBJ := $(SRC:.cpp=.o)
LDLIBS += -lpthread

.PHONY: all clean
all: $(BIN)
clean: cleandeps
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

include ../../Makefile.deps

=== test/Longevity/Makefile ===
include ../Makefile.common

BIN1 := main$(BIN_SUFFIX)
SRC1 := main.cpp
OBJ1 := $(SRC1:.cpp=.o)
BIN2 := main2$(BIN_SUFFIX)
SRC2 := main2.cpp
OBJ2 := $(SRC2:.cpp=.o)
CXXFLAGS := $(CXXWARNFLAGS) -g -fexpensive-optimizations -O3

.PHONY: all clean
all: $(BIN1) $(BIN2)
clean: cleandeps
	$(RM) $(BIN1)
	$(RM) $(OBJ1)
	$(RM) $(BIN2)
	$(RM) $(OBJ2)

$(BIN1): $(OBJ1)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(BIN2): $(OBJ2)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

include ../../Makefile.deps

=== test/OrderedStatic/Makefile ===
include ../Makefile.common

BIN := main$(BIN_SUFFIX)
SRC := main.cpp
OBJ := $(SRC:.cpp=.o)

.PHONY: all clean
all: $(BIN)
clean: cleandeps
	$(RM) $(BIN)
	$(RM) $(OBJ)

$(BIN): $(OBJ)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDLIBS)

include ../../Makefile.deps

=== test/Register/Makefile ===
include ../Makefile.common

BIN1 := main$(BIN_SUFFIX)
SRC1 := main.cpp
OBJ1 := $(SRC1:.cpp=.o)
LIB1 := libfoo.a
SRC2 := foo.cpp
OBJ2 := $(SRC2:.cpp=.o)
CPPFLAGS += -DLOKI_FUNCTOR_IS_NOT_A_SMALLOBJECT

.PHONY: all clean
all: $(BIN1)

$(BIN1): $(OBJ1) $(LIB1) 
	$(CXX) $(CXXFLAGS) -L. $(LDFLAGS) $(CPPFLAGS) -o $@ $(OBJ1) $(LDLIBS) -lfoo

$(LIB1): $(OBJ2)
	$(AR) $(ARFLAGS) $@ $^

clean: cleandeps
	$(RM) $(BIN1)
	$(RM) $(OBJ1)
	$(RM) $(LIB1)
	$(RM) $(OBJ2)

include ../../Makefile.deps

=== debian/changelog ===
libloki (0.1.7-6) unstable; urgency=medium

  * QA upload.

  [ Petter Reinholdtsen ]
  * New uploading using new ABI (Closes: #865527).
  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 3.9.2 to 4.7.0.
  * Use wrap-and-sort -at for debian control files.
  * Update watch file format version to 4.
  * Marked libloki-doc as multi-arch: foreign.

  [ Vagrant Cascadian ]
  * debian/rules: Explicitly pass CXXFLAGS to dh_auto_build (Closes: #1014559).

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 22 Nov 2024 08:56:15 +0100

libloki (0.1.7-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062402

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 18:24:01 +0000

libloki (0.1.7-5) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with GCC 11, thanks to Lukas Märdian.  (Closes: #984186)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 19 Oct 2021 22:04:10 +0200

libloki (0.1.7-4) unstable; urgency=medium

  [ Andreas Beckmann ]
  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #981053)
    (Closes: #979357, #836838)
  * Drop -dbg package in favor of autogenerated -dbgsym package.
  * Switch to source format 3.0 (quilt).
  * Switch to debhelper-compat (= 13).

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_build pass cross tools to make. (Closes: #928859)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 26 Jan 2021 02:01:02 +0100

libloki (0.1.7-3.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Tue, 05 Jan 2021 18:30:32 +0100

libloki (0.1.7-3) unstable; urgency=low

  * New maintainer. (Closes: #620021)
  * Sponsored by Al Nikolov <clown@debian.org>.
  * Update Standards-Version (no changes)
  * debian/control: add ${misc:Depends}
  * debian/control: fix synopsis

 -- Petr Baranov <petr@baranov.fi>  Mon, 27 Jun 2011 11:27:45 +0300

libloki (0.1.7-2) unstable; urgency=low

  * fix yasli/random.h - error in bug number :) (Closes: #503829)
    (only wrong number - fixed in 0.1.7-1)
  * add watch file
  * Update Standards-Version (no changes)

 -- Ivan Borzenkov <ivan1986@list.ru>  Sun, 30 Aug 2009 18:05:45 +0400

libloki (0.1.7-1) unstable; urgency=low

  * New upstream release
  * New mantainer. (Closes: #508085)
  * No needed rename (Closes: #430268)
  * fix yasli/random.h (Closes: #512044)
  * Update Standards-Version (no changes)

 -- Ivan Borzenkov <ivan1986@list.ru>  Fri, 08 May 2009 23:07:37 +0400

libloki (0.1.5-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS with gcc-4.3 (closes: #413432)
  * Update Standards-Version (no changes)
  * Make lintian happy:
    - Change from Source-Version to binary:Version in debian/control
    - Don't ignore errors on clean
    - Add copyright symbol to debian/copyright
    - Move Homepage: from description to control field
    - Register doc-base files with right section

 -- Stephen Gran <sgran@debian.org>  Sat, 05 Apr 2008 14:57:24 +0100

libloki (0.1.5-3) unstable; urgency=low

  * debian/rules: Always build with OS=Linux to fix FTBFS on kFreeBSD, Hurd
    thanks to Petr Salinger (Closes: #392350)
  * debian/control: Remove libloki-dev Depends on libc-dev, c++abi2-dev
    they are already drawn in by build-essential
  * debian/control: Priority should be optional, not extra
  * debian/rules: Remove useless comments
  * debian/rules: Set CXXFLAGS, not CFLAGS
  * debian/copyright: Add myself as having "cleaned up" the package

 -- Lukas Fittl <lfittl@fsfe.org>  Mon,  6 Nov 2006 20:06:35 +0100

libloki (0.1.5-2) unstable; urgency=low

  * Add debian/libloki-doc.doc-base (Closes: #390976)

 -- Lukas Fittl <lfittl@fsfe.org>  Wed,  4 Oct 2006 08:31:41 +0200

libloki (0.1.5-1) unstable; urgency=low

  * New upstream release (Closes: #386825)
  * debian/control: Adopt the package
  * debian/control: Update to Standards-Version 3.7.2, no changes needed
  * debian/compat, debian/control: Use debhelper compat level 5,
    no changes needed
  * debian/README.Debian: Update book website address (Closes: #336889)
  * debian/copyright: Update copyright summary
  * debian/rules: Cleanup
  * debian/README.Debian: Replace 'Debian GNU/Linux',
    there is also kfreebsd and hurd
  * debian/README.Debian, rename to libloki-dev.README.Debian, as
    only developer information is in there
  * Drop debian/patches
    - debian/patches/50-pkgconfig.dpatch: pkg-config is not needed for
      this package
    - debian/patches/20-Makefile.dpatch: Merged upstream and later removed,
      because the original Makefile has been fixed
    - debian/rules: Remove dpatch parts
    - debian/control: Remove Build-Depends on dpatch
  * src/Makefile: Avoid FTBFS by overriding CPPFLAGS and LDFLAGS
    (taken from upstream cvs)
  * src/Makefile: Link after calling install, otherwise we end up with
    2 copies of the lib and no links (taken from upstream cvs)
  * Build shared library packages
    - debian/control: Add libloki{-dbg,0.1.5} packages
    - debian/README.Debian: Remove obsolete 'About the package' section
    - Add debian/libloki-dev.install
    - Add debian/libloki0.1.5.install
  * Install doxygen documentation
    - debian/control: Add libloki-doc package
    - Add debian/libloki-doc.install

 -- Lukas Fittl <lfittl@fsfe.org>  Mon, 11 Sep 2006 23:36:20 +0200

libloki (0.0.20030413-2) unstable; urgency=low

  * Removed suggestion on libtut-doc. Oops.
  * Added more notes to README.Debian.

 -- martin f. krafft <madduck@debian.org>  Sat, 14 May 2005 20:02:11 +0200

libloki (0.0.20030413-1) unstable; urgency=low

  * Initial release (closes: Bug#251229).

 -- martin f. krafft <madduck@debian.org>  Wed, 11 May 2005 21:44:44 +0200

=== debian/control ===
Source: libloki
Section: libs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
Standards-Version: 4.7.0
Homepage: https://loki-lib.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/debian/libloki
Vcs-Git: https://salsa.debian.org/debian/libloki.git

Package: libloki0.1.7t64
Provides: ${t64:Provides},
Replaces: libloki0.1.7,
Breaks: libloki0.1.7 (<< ${source:Version}),
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: C++ library of generic design patterns
 Loki is a ("the"?) C++ library of generic programming techniques, containing
 flexible implementations of common design patterns and idioms. It is an
 essential library for modern C++ programming and exposes many cool features
 of the language.
 .
 The code accompanies the (non-free) book, _Modern C++ Design_ (Alexandrescu,
 2001), which goes into depth on the design of the library.

Package: libloki-dev
Section: libdevel
Architecture: any
Depends: libloki0.1.7t64 (= ${binary:Version}),
         ${misc:Depends},
Suggests: libloki-doc,
Description: C++ library of generic design patterns (development files)
 Loki is a ("the"?) C++ library of generic programming techniques, containing
 flexible implementations of common design patterns and idioms. It is an
 essential library for modern C++ programming and exposes many cool features
 of the language.
 .
 The code accompanies the (non-free) book, _Modern C++ Design_ (Alexandrescu,
 2001), which goes into depth on the design of the library.
 .
 This package contains the header files and static libraries needed
 to build programs that use loki.

Package: libloki-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: C++ library of generic design patterns (documentation)
 Loki is a ("the"?) C++ library of generic programming techniques, containing
 flexible implementations of common design patterns and idioms. It is an
 essential library for modern C++ programming and exposes many cool features
 of the language.
 .
 This package contains the generated doxygen documentation for loki.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- OS=Linux build-static build-shared CXXFLAGS="$(CXXFLAGS)"

override_dh_auto_test:
	-dh_auto_test -- OS=Linux

override_dh_auto_install:
	dh_auto_install -- OS=Linux install prefix=$(CURDIR)/debian/tmp/usr

=== debian/watch ===
version=4
http://sf.net/loki-lib/ loki-(.+)\.tar\.gz
